﻿package view.components {
	import fl.motion.easing.Cubic;
	import flash.display.MovieClip;
	import flash.events.Event;
	import fl.transitions.easing.Strong;
	
	import gs.TweenLite;
	
	// Import Papervision3D
	import org.papervision3d.cameras.*;
	import org.papervision3d.scenes.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.objects.special.*;
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.special.*;
	import org.papervision3d.materials.shaders.*;
	import org.papervision3d.materials.utils.*;
	import org.papervision3d.lights.*;
	import org.papervision3d.render.*;
	import org.papervision3d.view.*;
	import org.papervision3d.events.*;
	import org.papervision3d.core.utils.*;
	import org.papervision3d.core.utils.virtualmouse.VirtualMouse;
	
	public class Card extends MovieClip {
		
		private var _viewport:Viewport3D;
		private var _scene:Scene3D;
		private var _camera:Camera3D;
		private var _plane:Cube;
		private var _renderer:BasicRenderEngine;
		
		private var _page:Number = 0;

		
		public function Card() {
			init();
		}
		
		private function init():void {
			init3D();
			
			addEventListener( Event.ENTER_FRAME, loop );
		}
		
		private function init3D():void {
			// Create viewport
			_viewport = new Viewport3D(520, 480);
			addChild( _viewport );
			
			_renderer = new BasicRenderEngine();
			
			// Create scene
			_scene = new Scene3D();
			
			var materials:MaterialsList = new MaterialsList(
			{
				all:	new LineMaterial(0xFFFFFF),
				front:  new ColorMaterial(0xFF0000),
				back:   new ColorMaterial(0x00FF00),
				right:  new ColorMaterial(0x0000FF),
				left:   new ColorMaterial(0x0000CC),
				top:    new ColorMaterial(0x999999),
				bottom: new ColorMaterial(0x666666)
			} );
			_plane = new Cube( materials, 300, 30, 300 );
			_scene.addChild(_plane);
			
			_camera = new Camera3D();
			_camera.zoom = 100;
			_camera.y = 300;
			_camera.lookAt(_plane);
			
			
		}
		
		public function loop(e:Event):void {
			_renderer.renderScene(_scene, _camera, _viewport);
		}
		
		public function rotateCard($degree:Number):void {
			_page = _page + $degree;
			TweenLite.to( _plane, 1, { rotationY:_page*180, ease:Strong.easeOut } );
		}
	}
	
}